# coding: utf-8

"""
    IGX Platform Public API

    The IGX Platform Public API is a powerful API that enables a wide variety of use cases.                 The architecture of the IGX Platform centers around files, collections, tags and analyses,                 securely managed through cloud-based access.                 The Public API can be used to easily import data, annotate metadata, run analyses and export results.

    The version of the OpenAPI document: 1.0.0
    Contact: info@enpicom.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from igx_api.l1.openapi_client.models.search_and_tag import SearchAndTag
from igx_api.l1.openapi_client.models.templated_search_and_tag import TemplatedSearchAndTag
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

IMPORTMETADATAREQUEST_ONE_OF_SCHEMAS = ["SearchAndTag", "TemplatedSearchAndTag"]

class ImportMetadataRequest(BaseModel):
    """
    ImportMetadataRequest
    """
    # data type: TemplatedSearchAndTag
    oneof_schema_1_validator: Optional[TemplatedSearchAndTag] = None
    # data type: SearchAndTag
    oneof_schema_2_validator: Optional[SearchAndTag] = None
    actual_instance: Optional[Union[SearchAndTag, TemplatedSearchAndTag]] = None
    one_of_schemas: Set[str] = { "SearchAndTag", "TemplatedSearchAndTag" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = ImportMetadataRequest.model_construct()
        error_messages = []
        match = 0
        # validate data type: TemplatedSearchAndTag
        if not isinstance(v, TemplatedSearchAndTag):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TemplatedSearchAndTag`")
        else:
            match += 1
        # validate data type: SearchAndTag
        if not isinstance(v, SearchAndTag):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SearchAndTag`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in ImportMetadataRequest with oneOf schemas: SearchAndTag, TemplatedSearchAndTag. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in ImportMetadataRequest with oneOf schemas: SearchAndTag, TemplatedSearchAndTag. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into TemplatedSearchAndTag
        try:
            instance.actual_instance = TemplatedSearchAndTag.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into SearchAndTag
        try:
            instance.actual_instance = SearchAndTag.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into ImportMetadataRequest with oneOf schemas: SearchAndTag, TemplatedSearchAndTag. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into ImportMetadataRequest with oneOf schemas: SearchAndTag, TemplatedSearchAndTag. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], SearchAndTag, TemplatedSearchAndTag]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


