# coding: utf-8

"""
    IGX Platform Public API

    The IGX Platform Public API is a powerful API that enables a wide variety of use cases.                 The architecture of the IGX Platform centers around files, collections, tags and analyses,                 securely managed through cloud-based access.                 The Public API can be used to easily import data, annotate metadata, run analyses and export results.

    The version of the OpenAPI document: 1.0.0
    Contact: info@enpicom.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class MlOutputIntentOneOf1(BaseModel):
    """
    MlOutputIntentOneOf1
    """ # noqa: E501
    chain: Optional[StrictStr] = None
    output_key: Optional[StrictStr] = None
    tag_id: StrictInt
    tag_organization_id: Optional[StrictInt] = None
    type: StrictStr
    __properties: ClassVar[List[str]] = ["chain", "output_key", "tag_id", "tag_organization_id", "type"]

    @field_validator('chain')
    def chain_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Heavy', 'Light', 'Kappa', 'Lambda', 'Alpha', 'Beta', 'Gamma', 'Delta']):
            raise ValueError("must be one of enum values ('Heavy', 'Light', 'Kappa', 'Lambda', 'Alpha', 'Beta', 'Gamma', 'Delta')")
        return value

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['metadata']):
            raise ValueError("must be one of enum values ('metadata')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MlOutputIntentOneOf1 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if chain (nullable) is None
        # and model_fields_set contains the field
        if self.chain is None and "chain" in self.model_fields_set:
            _dict['chain'] = None

        # set to None if output_key (nullable) is None
        # and model_fields_set contains the field
        if self.output_key is None and "output_key" in self.model_fields_set:
            _dict['output_key'] = None

        # set to None if tag_organization_id (nullable) is None
        # and model_fields_set contains the field
        if self.tag_organization_id is None and "tag_organization_id" in self.model_fields_set:
            _dict['tag_organization_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MlOutputIntentOneOf1 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "chain": obj.get("chain"),
            "output_key": obj.get("output_key"),
            "tag_id": obj.get("tag_id"),
            "tag_organization_id": obj.get("tag_organization_id"),
            "type": obj.get("type")
        })
        return _obj


