# coding: utf-8

"""
    IGX Platform Public API

    The IGX Platform Public API is a powerful API that enables a wide variety of use cases.                 The architecture of the IGX Platform centers around files, collections, tags and analyses,                 securely managed through cloud-based access.                 The Public API can be used to easily import data, annotate metadata, run analyses and export results.

    The version of the OpenAPI document: 1.0.0
    Contact: info@enpicom.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from igx_api.l1.openapi_client.models.match_a_file_by_its_id import MatchAFileByItsID
from igx_api.l1.openapi_client.models.search_if_a_filename_contains_the_value import SearchIfAFilenameContainsTheValue
from igx_api.l1.openapi_client.models.search_if_a_tag_contains_the_value import SearchIfATagContainsTheValue
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

SEQUENCETEMPLATESELECTOR_ONE_OF_SCHEMAS = ["MatchAFileByItsID", "SearchIfAFilenameContainsTheValue", "SearchIfATagContainsTheValue"]

class SequenceTemplateSelector(BaseModel):
    """
    SequenceTemplateSelector
    """
    # data type: MatchAFileByItsID
    oneof_schema_1_validator: Optional[MatchAFileByItsID] = None
    # data type: SearchIfAFilenameContainsTheValue
    oneof_schema_2_validator: Optional[SearchIfAFilenameContainsTheValue] = None
    # data type: SearchIfATagContainsTheValue
    oneof_schema_3_validator: Optional[SearchIfATagContainsTheValue] = None
    actual_instance: Optional[Union[MatchAFileByItsID, SearchIfAFilenameContainsTheValue, SearchIfATagContainsTheValue]] = None
    one_of_schemas: Set[str] = { "MatchAFileByItsID", "SearchIfAFilenameContainsTheValue", "SearchIfATagContainsTheValue" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = SequenceTemplateSelector.model_construct()
        error_messages = []
        match = 0
        # validate data type: MatchAFileByItsID
        if not isinstance(v, MatchAFileByItsID):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MatchAFileByItsID`")
        else:
            match += 1
        # validate data type: SearchIfAFilenameContainsTheValue
        if not isinstance(v, SearchIfAFilenameContainsTheValue):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SearchIfAFilenameContainsTheValue`")
        else:
            match += 1
        # validate data type: SearchIfATagContainsTheValue
        if not isinstance(v, SearchIfATagContainsTheValue):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SearchIfATagContainsTheValue`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in SequenceTemplateSelector with oneOf schemas: MatchAFileByItsID, SearchIfAFilenameContainsTheValue, SearchIfATagContainsTheValue. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in SequenceTemplateSelector with oneOf schemas: MatchAFileByItsID, SearchIfAFilenameContainsTheValue, SearchIfATagContainsTheValue. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into MatchAFileByItsID
        try:
            instance.actual_instance = MatchAFileByItsID.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into SearchIfAFilenameContainsTheValue
        try:
            instance.actual_instance = SearchIfAFilenameContainsTheValue.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into SearchIfATagContainsTheValue
        try:
            instance.actual_instance = SearchIfATagContainsTheValue.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into SequenceTemplateSelector with oneOf schemas: MatchAFileByItsID, SearchIfAFilenameContainsTheValue, SearchIfATagContainsTheValue. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into SequenceTemplateSelector with oneOf schemas: MatchAFileByItsID, SearchIfAFilenameContainsTheValue, SearchIfATagContainsTheValue. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], MatchAFileByItsID, SearchIfAFilenameContainsTheValue, SearchIfATagContainsTheValue]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


