# coding: utf-8

"""
    IGX Platform Public API

    The IGX Platform Public API is a powerful API that enables a wide variety of use cases.                 The architecture of the IGX Platform centers around files, collections, tags and analyses,                 securely managed through cloud-based access.                 The Public API can be used to easily import data, annotate metadata, run analyses and export results.

    The version of the OpenAPI document: 1.0.0
    Contact: info@enpicom.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List
from typing import Optional, Set
from typing_extensions import Self

class StartFastaClonesExportRequestBodyFastaConfigHeaders(BaseModel):
    """
    Configuration of headers in the exported FASTA file.
    """ # noqa: E501
    include_unique_clone_id: StrictBool = Field(description="Determines if sequence headers in FASTA file will contain Unique Clone Ids.")
    include_unique_sequence_id: StrictBool = Field(description="Determines if sequence headers in FASTA file will contain Unique Sequence Ids.")
    include_chain: StrictBool = Field(description="Determines if sequence headers in FASTA file will contain sequence Chain types.")
    tags: List[StrictInt] = Field(description="IDs of tags that will be added into sequence headers. They will be displayed as their keys.")
    __properties: ClassVar[List[str]] = ["include_unique_clone_id", "include_unique_sequence_id", "include_chain", "tags"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of StartFastaClonesExportRequestBodyFastaConfigHeaders from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of StartFastaClonesExportRequestBodyFastaConfigHeaders from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "include_unique_clone_id": obj.get("include_unique_clone_id"),
            "include_unique_sequence_id": obj.get("include_unique_sequence_id"),
            "include_chain": obj.get("include_chain"),
            "tags": obj.get("tags")
        })
        return _obj


